Index: code/branches/cpp11_v2/src/orxonox/PlayerManager.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/PlayerManager.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/PlayerManager.h	(revision 10845)
@@ -50,6 +50,6 @@
                 { return this->clients_; }
 
-            void clientConnected(unsigned int clientID) override;
-            void clientDisconnected(unsigned int clientID) override;
+            virtual void clientConnected(unsigned int clientID) override;
+            virtual void clientDisconnected(unsigned int clientID) override;
             void disconnectAllClients();
 
Index: code/branches/cpp11_v2/src/orxonox/Scene.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/Scene.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/Scene.h	(revision 10845)
@@ -80,5 +80,5 @@
                 { return this->radar_; }
 
-            inline virtual uint32_t getSceneID() const override { return this->getObjectID(); }
+            virtual inline uint32_t getSceneID() const override { return this->getObjectID(); }
 
             virtual void tick(float dt) override;
Index: code/branches/cpp11_v2/src/orxonox/chat/ChatInputHandler.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/chat/ChatInputHandler.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/chat/ChatInputHandler.h	(revision 10845)
@@ -125,5 +125,5 @@
        * history window of the full chat window)
        */
-      void incomingChat(const std::string& message, const std::string& name) override;
+      virtual void incomingChat(const std::string& message, const std::string& name) override;
 
       /** \param full true means show full chat window with history,
Index: code/branches/cpp11_v2/src/orxonox/collisionshapes/CompoundCollisionShape.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/collisionshapes/CompoundCollisionShape.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/collisionshapes/CompoundCollisionShape.h	(revision 10845)
@@ -74,5 +74,5 @@
         private:
             void updatePublicShape();
-            inline virtual btCollisionShape* createNewShape() const override
+            virtual inline btCollisionShape* createNewShape() const override
                 { assert(false); return nullptr; }
 
Index: code/branches/cpp11_v2/src/orxonox/collisionshapes/WorldEntityCollisionShape.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/collisionshapes/WorldEntityCollisionShape.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/collisionshapes/WorldEntityCollisionShape.h	(revision 10845)
@@ -49,5 +49,5 @@
 
         private:
-            void parentChanged() override;
+            virtual void parentChanged() override;
 
             WorldEntity* worldEntityOwner_;
Index: code/branches/cpp11_v2/src/orxonox/gamestates/GSClient.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gamestates/GSClient.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gamestates/GSClient.h	(revision 10845)
@@ -43,7 +43,7 @@
         ~GSClient();
 
-        void activate() override;
-        void deactivate() override;
-        void update(const Clock& time) override;
+        virtual void activate() override;
+        virtual void deactivate() override;
+        virtual void update(const Clock& time) override;
     };
 }
Index: code/branches/cpp11_v2/src/orxonox/gamestates/GSGraphics.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gamestates/GSGraphics.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gamestates/GSGraphics.h	(revision 10845)
@@ -53,7 +53,7 @@
         ~GSGraphics();
 
-        void activate() override;
-        void deactivate() override;
-        void update(const Clock& time) override;
+        virtual void activate() override;
+        virtual void deactivate() override;
+        virtual void update(const Clock& time) override;
 
     private:
Index: code/branches/cpp11_v2/src/orxonox/gamestates/GSLevel.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gamestates/GSLevel.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gamestates/GSLevel.h	(revision 10845)
@@ -44,7 +44,7 @@
         ~GSLevel();
 
-        void activate() override;
-        void deactivate() override;
-        void update(const Clock& time) override;
+        virtual void activate() override;
+        virtual void deactivate() override;
+        virtual void update(const Clock& time) override;
 
         static void startMainMenu(void); //!< Starts the MainMenu
Index: code/branches/cpp11_v2/src/orxonox/gamestates/GSMainMenu.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gamestates/GSMainMenu.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gamestates/GSMainMenu.h	(revision 10845)
@@ -44,7 +44,7 @@
         ~GSMainMenu();
 
-        void activate() override;
-        void deactivate() override;
-        void update(const Clock& time) override;
+        virtual void activate() override;
+        virtual void deactivate() override;
+        virtual void update(const Clock& time) override;
 
         void setConfigValues();
Index: code/branches/cpp11_v2/src/orxonox/gamestates/GSMasterServer.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gamestates/GSMasterServer.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gamestates/GSMasterServer.h	(revision 10845)
@@ -45,7 +45,7 @@
       ~GSMasterServer();
 
-      void activate() override;
-      void deactivate() override;
-      void update(const Clock& time) override;
+      virtual void activate() override;
+      virtual void deactivate() override;
+      virtual void update(const Clock& time) override;
 
     private:
Index: code/branches/cpp11_v2/src/orxonox/gamestates/GSRoot.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gamestates/GSRoot.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gamestates/GSRoot.h	(revision 10845)
@@ -44,7 +44,7 @@
         static void printObjects();
 
-        void activate() override;
-        void deactivate() override;
-        void update(const Clock& time) override;
+        virtual void activate() override;
+        virtual void deactivate() override;
+        virtual void update(const Clock& time) override;
 
         // this has to be public because proteced triggers a bug in msvc
Index: code/branches/cpp11_v2/src/orxonox/gamestates/GSServer.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gamestates/GSServer.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gamestates/GSServer.h	(revision 10845)
@@ -43,7 +43,7 @@
         ~GSServer();
 
-        void activate() override;
-        void deactivate() override;
-        void update(const Clock& time) override;
+        virtual void activate() override;
+        virtual void deactivate() override;
+        virtual void update(const Clock& time) override;
 
     private:
Index: code/branches/cpp11_v2/src/orxonox/gamestates/GSStandalone.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gamestates/GSStandalone.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gamestates/GSStandalone.h	(revision 10845)
@@ -41,7 +41,7 @@
         ~GSStandalone();
 
-        void activate() override;
-        void deactivate() override;
-        void update(const Clock& time) override;
+        virtual void activate() override;
+        virtual void deactivate() override;
+        virtual void update(const Clock& time) override;
 
     private:
Index: code/branches/cpp11_v2/src/orxonox/gametypes/Dynamicmatch.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gametypes/Dynamicmatch.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gametypes/Dynamicmatch.h	(revision 10845)
@@ -78,6 +78,6 @@
             void grantPigBoost(SpaceShip* spaceship); // Grant the piggy a boost.
             void resetSpeedFactor(SpaceShip* spaceship);
-            void tick (float dt) override;// used to end the game
-            SpawnPoint* getBestSpawnPoint(PlayerInfo* player) const override;
+            virtual void tick (float dt) override;// used to end the game
+            virtual SpawnPoint* getBestSpawnPoint(PlayerInfo* player) const override;
 
 
Index: code/branches/cpp11_v2/src/orxonox/gametypes/LastManStanding.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gametypes/LastManStanding.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gametypes/LastManStanding.h	(revision 10845)
@@ -80,5 +80,5 @@
 
             void punishPlayer(PlayerInfo* player); //!< Function in order to kill a player. Punishment for hiding longer than "timeRemaining".
-            void tick (float dt) override; //!< used to end the game
+            virtual void tick (float dt) override; //!< used to end the game
     };
 }
Index: code/branches/cpp11_v2/src/orxonox/gametypes/LastTeamStanding.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gametypes/LastTeamStanding.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gametypes/LastTeamStanding.h	(revision 10845)
@@ -80,5 +80,5 @@
             virtual bool allowPawnDamage(Pawn* victim, Pawn* originator = nullptr) override; //!< If a player shoot's an opponent, his punishment countdown will be resetted.
             virtual void playerStartsControllingPawn(PlayerInfo* player, Pawn* pawn) override; //!< Resets punishment time and respawn delay.
-            void tick (float dt) override; //!< used to end the game
+            virtual void tick (float dt) override; //!< used to end the game
             virtual void end() override; //!< Sends an end message.
             void punishPlayer(PlayerInfo* player); //!< Function in order to kill a player. Punishment for hiding longer than "timeRemaining".
Index: code/branches/cpp11_v2/src/orxonox/gametypes/UnderAttack.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/gametypes/UnderAttack.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/gametypes/UnderAttack.h	(revision 10845)
@@ -43,5 +43,5 @@
 
             void setConfigValues();
-            void tick (float dt) override;
+            virtual void tick (float dt) override;
             void addDestroyer(Destroyer* destroyer);
             inline Destroyer* getDestroyer() const
Index: code/branches/cpp11_v2/src/orxonox/graphics/Camera.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/graphics/Camera.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/graphics/Camera.h	(revision 10845)
@@ -72,5 +72,5 @@
             void configvaluecallback_changedNearClipDistance();
 
-            void windowResized(unsigned int newWidth, unsigned int newHeight) override;
+            virtual void windowResized(unsigned int newWidth, unsigned int newHeight) override;
 
             Ogre::Camera*    camera_;
Index: code/branches/cpp11_v2/src/orxonox/infos/Bot.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/infos/Bot.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/infos/Bot.h	(revision 10845)
@@ -45,9 +45,9 @@
             void setConfigValues();
 
-            inline bool isInitialized() const override
+            virtual inline bool isInitialized() const override
                 { return true; }
-            inline float getPing() const override
+            virtual inline float getPing() const override
                 { return 0; }
-            inline float getPacketLossRatio() const override
+            virtual inline float getPacketLossRatio() const override
                 { return 0; }
 
Index: code/branches/cpp11_v2/src/orxonox/infos/HumanPlayer.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/infos/HumanPlayer.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/infos/HumanPlayer.h	(revision 10845)
@@ -45,7 +45,7 @@
             void setConfigValues();
 
-            bool isInitialized() const override;
-            float getPing() const override;
-            float getPacketLossRatio() const override;
+            virtual bool isInitialized() const override;
+            virtual float getPing() const override;
+            virtual float getPacketLossRatio() const override;
 
             void setClientID(unsigned int clientID);
Index: code/branches/cpp11_v2/src/orxonox/interfaces/PickupCarrier.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/interfaces/PickupCarrier.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/interfaces/PickupCarrier.h	(revision 10845)
@@ -77,5 +77,5 @@
             PickupCarrier(); //!< Constructor.
             virtual ~PickupCarrier(); //!< Destructor.
-            void preDestroy(void) override; //!< Is called before the PickupCarrier is effectively destroyed.
+            virtual void preDestroy(void) override; //!< Is called before the PickupCarrier is effectively destroyed.
 
             bool isTarget(const Pickupable* pickup) const; //!< Can be used to check whether the PickupCarrier or a child of his is a target ot the input Pickupable.
Index: code/branches/cpp11_v2/src/orxonox/overlays/GUISheet.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/overlays/GUISheet.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/overlays/GUISheet.h	(revision 10845)
@@ -44,5 +44,5 @@
         ~GUISheet();
 
-        void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
 
         void show();
Index: code/branches/cpp11_v2/src/orxonox/overlays/InGameConsole.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/overlays/InGameConsole.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/overlays/InGameConsole.h	(revision 10845)
@@ -53,6 +53,6 @@
         void setConfigValues();
 
-        void preUpdate(const Clock& time) override;
-        void postUpdate(const Clock& time) override { /*no action*/ }
+        virtual void preUpdate(const Clock& time) override;
+        virtual void postUpdate(const Clock& time) override { /*no action*/ }
 
         static void openConsole();
@@ -65,10 +65,10 @@
         void deactivate();
 
-        void linesChanged() override;
-        void lineAdded() override;
-        void inputChanged() override;
-        void cursorChanged() override;
-        void executed() override;
-        void exit() override;
+        virtual void linesChanged() override;
+        virtual void lineAdded() override;
+        virtual void inputChanged() override;
+        virtual void cursorChanged() override;
+        virtual void executed() override;
+        virtual void exit() override;
 
         void shiftLines();
@@ -77,5 +77,5 @@
         void print(const std::string& text, Shell::LineType type, int index, bool alwaysShift = false);
 
-        void windowResized(unsigned int newWidth, unsigned int newHeight) override;
+        virtual void windowResized(unsigned int newWidth, unsigned int newHeight) override;
 
         // config value related
Index: code/branches/cpp11_v2/src/orxonox/overlays/OrxonoxOverlay.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/overlays/OrxonoxOverlay.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/overlays/OrxonoxOverlay.h	(revision 10845)
@@ -206,5 +206,5 @@
 
     private:
-        void windowResized(unsigned int newWidth, unsigned int newHeight) override;
+        virtual void windowResized(unsigned int newWidth, unsigned int newHeight) override;
 
         static unsigned int hudOverlayCounter_s;   //!< Static counter for hud elements
Index: code/branches/cpp11_v2/src/orxonox/sound/AmbientSound.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/sound/AmbientSound.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/sound/AmbientSound.h	(revision 10845)
@@ -50,7 +50,7 @@
         AmbientSound();
 
-        void play() override;
-        bool stop() override;
-        void pause() override;
+        virtual void play() override;
+        virtual bool stop() override;
+        virtual void pause() override;
 
         bool setAmbientSource(const std::string& source);
@@ -66,7 +66,7 @@
 
     private:
-        void preDestroy() override;
-        float getRealVolume() override;
-        bool moodChanged(const std::string& mood) override;
+        virtual void preDestroy() override;
+        virtual float getRealVolume() override;
+        virtual bool moodChanged(const std::string& mood) override;
         inline void ambientSourceChanged()
             { this->setAmbientSource(this->ambientSource_); }
Index: code/branches/cpp11_v2/src/orxonox/sound/SoundManager.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/sound/SoundManager.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/sound/SoundManager.h	(revision 10845)
@@ -68,6 +68,6 @@
         ~SoundManager();
 
-        void preUpdate(const Clock& time) override;
-        void postUpdate(const Clock& time) override { /*no action*/ }
+        virtual void preUpdate(const Clock& time) override;
+        virtual void postUpdate(const Clock& time) override { /*no action*/ }
         void setConfigValues();
 
Index: code/branches/cpp11_v2/src/orxonox/sound/WorldAmbientSound.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/sound/WorldAmbientSound.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/sound/WorldAmbientSound.h	(revision 10845)
@@ -50,6 +50,6 @@
             virtual ~WorldAmbientSound();
 
-            void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
-            void XMLEventPort(Element& xmlelement, XMLPort::Mode mode) override;
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+            virtual void XMLEventPort(Element& xmlelement, XMLPort::Mode mode) override;
 
             virtual void changedActivity() override;
Index: code/branches/cpp11_v2/src/orxonox/sound/WorldSound.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/sound/WorldSound.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/sound/WorldSound.h	(revision 10845)
@@ -47,9 +47,9 @@
         WorldSound(Context* context);
 
-        void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
-        void XMLEventPort(Element& xmlelement, XMLPort::Mode mode) override;
-        void changedActivity() override;
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+        virtual void XMLEventPort(Element& xmlelement, XMLPort::Mode mode) override;
+        virtual void changedActivity() override;
 
-        void tick(float dt) override;
+        virtual void tick(float dt) override;
 
     protected:
@@ -58,6 +58,6 @@
     private:
         void registerVariables();
-        void initialiseSource() override;
-        float getRealVolume() override;
+        virtual void initialiseSource() override;
+        virtual float getRealVolume() override;
     };
 }
Index: code/branches/cpp11_v2/src/orxonox/worldentities/ControllableEntity.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/worldentities/ControllableEntity.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/worldentities/ControllableEntity.h	(revision 10845)
@@ -141,8 +141,8 @@
             using MobileEntity::setAngularVelocity;
 
-            void setPosition(const Vector3& position) override;
-            void setOrientation(const Quaternion& orientation) override;
-            void setVelocity(const Vector3& velocity) override;
-            void setAngularVelocity(const Vector3& velocity) override;
+            virtual void setPosition(const Vector3& position) override;
+            virtual void setOrientation(const Quaternion& orientation) override;
+            virtual void setVelocity(const Vector3& velocity) override;
+            virtual void setAngularVelocity(const Vector3& velocity) override;
 
             inline bool hasLocalController() const
@@ -214,5 +214,5 @@
 
             // Bullet btMotionState related
-            void setWorldTransform(const btTransform& worldTrans) override;
+            virtual void setWorldTransform(const btTransform& worldTrans) override;
 
             unsigned int server_overwrite_;
Index: code/branches/cpp11_v2/src/orxonox/worldentities/MobileEntity.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/worldentities/MobileEntity.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/worldentities/MobileEntity.h	(revision 10845)
@@ -64,5 +64,5 @@
             inline void setVelocity(float x, float y, float z)
                 { this->setVelocity(Vector3(x, y, z)); }
-            inline const Vector3& getVelocity() const override
+            virtual inline const Vector3& getVelocity() const override
                 { return this->linearVelocity_; }
             /**
@@ -109,5 +109,5 @@
             // Bullet btMotionState related
             virtual void setWorldTransform(const btTransform& worldTrans) override;
-            void getWorldTransform(btTransform& worldTrans) const override;
+            virtual void getWorldTransform(btTransform& worldTrans) const override;
 
             Vector3 linearAcceleration_;
Index: code/branches/cpp11_v2/src/orxonox/worldentities/MovableEntity.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/worldentities/MovableEntity.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/worldentities/MovableEntity.h	(revision 10845)
@@ -52,7 +52,7 @@
             using WorldEntity::setOrientation;
 
-            inline void setPosition(const Vector3& position) override
+            virtual inline void setPosition(const Vector3& position) override
                 { MobileEntity::setPosition(position); this->overwrite_position_ = this->getPosition(); }
-            inline void setOrientation(const Quaternion& orientation) override
+            virtual inline void setOrientation(const Quaternion& orientation) override
                 { MobileEntity::setOrientation(orientation); this->overwrite_orientation_ = this->getOrientation(); }
 
@@ -79,6 +79,6 @@
         private:
             void registerVariables();
-            void clientConnected(unsigned int clientID) override;
-            void clientDisconnected(unsigned int clientID) override;
+            virtual void clientConnected(unsigned int clientID) override;
+            virtual void clientDisconnected(unsigned int clientID) override;
             void resynchronize();
 
Index: code/branches/cpp11_v2/src/orxonox/worldentities/StaticEntity.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/worldentities/StaticEntity.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/worldentities/StaticEntity.h	(revision 10845)
@@ -55,10 +55,10 @@
             using WorldEntity::setOrientation;
 
-            void setPosition(const Vector3& position) override;
-            void setOrientation(const Quaternion& orientation) override;
+            virtual void setPosition(const Vector3& position) override;
+            virtual void setOrientation(const Quaternion& orientation) override;
 
         private:
             void registerVariables();
-            bool isCollisionTypeLegal(CollisionType type) const override;
+            virtual bool isCollisionTypeLegal(CollisionType type) const override;
 
             // network callbacks
@@ -69,6 +69,6 @@
 
             // Bullet btMotionState related
-            void setWorldTransform(const btTransform& worldTrans) override;
-            void getWorldTransform(btTransform& worldTrans) const override;
+            virtual void setWorldTransform(const btTransform& worldTrans) override;
+            virtual void getWorldTransform(btTransform& worldTrans) const override;
     };
 }
Index: code/branches/cpp11_v2/src/orxonox/worldentities/pawns/FpsPlayer.h
===================================================================
--- code/branches/cpp11_v2/src/orxonox/worldentities/pawns/FpsPlayer.h	(revision 10821)
+++ code/branches/cpp11_v2/src/orxonox/worldentities/pawns/FpsPlayer.h	(revision 10845)
@@ -69,5 +69,5 @@
             virtual void fire();
 
-            bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* ownCollisionShape, btManifoldPoint& contactPoint) override;
+            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* ownCollisionShape, btManifoldPoint& contactPoint) override;
 
             virtual void addedWeaponPack(WeaponPack* wPack);