Index: /code/branches/cpp11_v2/test/core/class/IdentifiableTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/class/IdentifiableTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/class/IdentifiableTest.cc	(revision 10846)
@@ -20,5 +20,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -26,5 +26,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     ModuleInstance::getCurrentModuleInstance()->unloadAllStaticallyInitializedInstances(StaticInitialization::IDENTIFIER);
Index: /code/branches/cpp11_v2/test/core/class/IdentifierClassHierarchyTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/class/IdentifierClassHierarchyTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/class/IdentifierClassHierarchyTest.cc	(revision 10846)
@@ -86,5 +86,5 @@
                 }
 
-                virtual void test1() {}
+                virtual void test1() override {}
         };
 
@@ -97,6 +97,6 @@
                 }
 
-                virtual void test1() {}
-                virtual void test2() {}
+                virtual void test1() override {}
+                virtual void test2() override {}
         };
 
@@ -109,6 +109,6 @@
                 }
 
-                virtual void test1() {}
-                virtual void test2() {}
+                virtual void test1() override {}
+                virtual void test2() override {}
         };
 
@@ -121,6 +121,6 @@
                 }
 
-                virtual void test1() {}
-                virtual void test2() {}
+                virtual void test1() override {}
+                virtual void test2() override {}
         };
 
@@ -140,5 +140,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -149,5 +149,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     IdentifierManager::getInstance().destroyClassHierarchy();
Index: /code/branches/cpp11_v2/test/core/class/IdentifierExternalClassHierarchyTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/class/IdentifierExternalClassHierarchyTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/class/IdentifierExternalClassHierarchyTest.cc	(revision 10846)
@@ -36,5 +36,5 @@
                 }
 
-                virtual void test() {}
+                virtual void test() override {}
         };
 
@@ -47,5 +47,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -56,5 +56,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     IdentifierManager::getInstance().destroyClassHierarchy();
Index: /code/branches/cpp11_v2/test/core/class/IdentifierNestedClassHierarchyTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/class/IdentifierNestedClassHierarchyTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/class/IdentifierNestedClassHierarchyTest.cc	(revision 10846)
@@ -107,5 +107,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -116,5 +116,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     IdentifierManager::getInstance().destroyClassHierarchy();
Index: /code/branches/cpp11_v2/test/core/class/IdentifierSimpleClassHierarchyTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/class/IdentifierSimpleClassHierarchyTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/class/IdentifierSimpleClassHierarchyTest.cc	(revision 10846)
@@ -38,5 +38,5 @@
                 }
 
-                virtual void test() {}
+                virtual void test() override {}
         };
 
@@ -49,5 +49,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -58,5 +58,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     IdentifierManager::getInstance().destroyClassHierarchy();
Index: /code/branches/cpp11_v2/test/core/class/IdentifierTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/class/IdentifierTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/class/IdentifierTest.cc	(revision 10846)
@@ -27,5 +27,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -33,5 +33,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     ModuleInstance::getCurrentModuleInstance()->unloadAllStaticallyInitializedInstances(StaticInitialization::IDENTIFIER);
Index: /code/branches/cpp11_v2/test/core/class/OrxonoxClassTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/class/OrxonoxClassTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/class/OrxonoxClassTest.cc	(revision 10846)
@@ -16,5 +16,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -22,5 +22,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     Context::destroyRootContext();
Index: /code/branches/cpp11_v2/test/core/class/OrxonoxInterfaceTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/class/OrxonoxInterfaceTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/class/OrxonoxInterfaceTest.cc	(revision 10846)
@@ -31,5 +31,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -37,5 +37,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     Context::destroyRootContext();
Index: /code/branches/cpp11_v2/test/core/class/SubclassIdentifierTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/class/SubclassIdentifierTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/class/SubclassIdentifierTest.cc	(revision 10846)
@@ -29,5 +29,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -38,5 +38,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     IdentifierManager::getInstance().destroyClassHierarchy();
Index: /code/branches/cpp11_v2/test/core/class/SuperTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/class/SuperTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/class/SuperTest.cc	(revision 10846)
@@ -19,10 +19,10 @@
                 }
 
-                virtual void changedName()
+                virtual void changedName() override
                 {
                     this->changedNameBase_ = true;
                 }
 
-                virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode)
+                virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override
                 {
                     this->xmlPortBase_ = true;
@@ -43,5 +43,5 @@
                 }
 
-                virtual void changedName()
+                virtual void changedName() override
                 {
                     this->changedNameSubclass_ = true;
@@ -50,5 +50,5 @@
                 }
 
-                virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode)
+                virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override
                 {
                     this->xmlPortSubclass_ = true;
@@ -70,5 +70,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -79,5 +79,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     IdentifierManager::getInstance().destroyClassHierarchy();
Index: /code/branches/cpp11_v2/test/core/command/CommandTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/command/CommandTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/command/CommandTest.cc	(revision 10846)
@@ -138,5 +138,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -148,5 +148,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     IdentifierManager::getInstance().destroyClassHierarchy();
Index: /code/branches/cpp11_v2/test/core/command/ExecutorPtrTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/command/ExecutorPtrTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/command/ExecutorPtrTest.cc	(revision 10846)
@@ -21,9 +21,9 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                 }
Index: /code/branches/cpp11_v2/test/core/command/FunctorPtrTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/command/FunctorPtrTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/command/FunctorPtrTest.cc	(revision 10846)
@@ -21,9 +21,9 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                 }
Index: /code/branches/cpp11_v2/test/core/object/ClassFactoryTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/object/ClassFactoryTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/object/ClassFactoryTest.cc	(revision 10846)
@@ -14,5 +14,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -21,5 +21,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     Context::destroyRootContext();
Index: /code/branches/cpp11_v2/test/core/object/ContextTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/object/ContextTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/object/ContextTest.cc	(revision 10846)
@@ -21,5 +21,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -28,5 +28,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     Context::destroyRootContext();
Index: /code/branches/cpp11_v2/test/core/object/IteratorTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/object/IteratorTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/object/IteratorTest.cc	(revision 10846)
@@ -15,5 +15,5 @@
         {
             public:
-            TestInterface() { RegisterObject(TestInterface); }
+                TestInterface() { RegisterObject(TestInterface); }
         };
 
@@ -32,5 +32,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -39,5 +39,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     Context::destroyRootContext();
Index: /code/branches/cpp11_v2/test/core/object/ListableTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/object/ListableTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/object/ListableTest.cc	(revision 10846)
@@ -37,5 +37,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -44,5 +44,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     Context::destroyRootContext();
Index: /code/branches/cpp11_v2/test/core/object/ObjectListIteratorTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/object/ObjectListIteratorTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/object/ObjectListIteratorTest.cc	(revision 10846)
@@ -15,5 +15,5 @@
         {
             public:
-            TestInterface() { RegisterObject(TestInterface); }
+                TestInterface() { RegisterObject(TestInterface); }
         };
 
@@ -32,5 +32,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -39,5 +39,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     Context::destroyRootContext();
Index: /code/branches/cpp11_v2/test/core/object/ObjectListTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/object/ObjectListTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/object/ObjectListTest.cc	(revision 10846)
@@ -24,5 +24,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -31,5 +31,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     Context::destroyRootContext();
Index: /code/branches/cpp11_v2/test/core/singleton/ScopeTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/core/singleton/ScopeTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/core/singleton/ScopeTest.cc	(revision 10846)
@@ -26,5 +26,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     new IdentifierManager();
@@ -35,5 +35,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                     Context::destroyRootContext();
Index: /code/branches/cpp11_v2/test/util/output/BaseWriterTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/util/output/BaseWriterTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/util/output/BaseWriterTest.cc	(revision 10846)
@@ -30,5 +30,5 @@
                 MOCK_METHOD2(printLine, void(const std::string&, OutputLevel));
 
-                virtual void output(OutputLevel level, const OutputContextContainer& context, const std::vector<std::string>& lines)
+                virtual void output(OutputLevel level, const OutputContextContainer& context, const std::vector<std::string>& lines) override
                     { this->BaseWriter::output(level, context, lines); }
         };
Index: /code/branches/cpp11_v2/test/util/output/ConsoleWriterTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/util/output/ConsoleWriterTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/util/output/ConsoleWriterTest.cc	(revision 10846)
@@ -12,5 +12,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     // reset output manager
@@ -18,5 +18,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                 }
Index: /code/branches/cpp11_v2/test/util/output/LogWriterTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/util/output/LogWriterTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/util/output/LogWriterTest.cc	(revision 10846)
@@ -12,5 +12,5 @@
         {
             public:
-                virtual void printLine(const std::string& line, OutputLevel level)
+                virtual void printLine(const std::string& line, OutputLevel level) override
                     { this->LogWriter::printLine(line, level); }
         };
@@ -20,5 +20,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     // reset output manager
@@ -26,5 +26,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                 }
Index: /code/branches/cpp11_v2/test/util/output/MemoryWriterTest.cc
===================================================================
--- /code/branches/cpp11_v2/test/util/output/MemoryWriterTest.cc	(revision 10845)
+++ /code/branches/cpp11_v2/test/util/output/MemoryWriterTest.cc	(revision 10846)
@@ -19,5 +19,5 @@
         {
             public:
-                virtual void SetUp()
+                virtual void SetUp() override
                 {
                     // reset output manager
@@ -25,5 +25,5 @@
                 }
 
-                virtual void TearDown()
+                virtual void TearDown() override
                 {
                 }